//+------------------------------------------------------------------+
//|                                              TimeLineSpecial.mq4 |
//|                                      Copyright  2012, Madhatt30 |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Madhatt30."

#property indicator_chart_window
//--- input parameters
extern color     LineColor=Gray;
extern int LineWidth=1;
extern int LineStyle=1;
extern bool ShowSweetSpot=true;
extern int SweetSpotLength=8;
extern color SweetSpotColor=C'150,150,150';
extern color ExpSweetSpotCol=C'160,160,160';
extern bool Back=true;
extern int History=5000;

static string prevOptLine="-";
static string prevSPLine="";
static double WinMax, WinMin;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   WinMax=2.5000;
   WinMin=0.5000;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   //int    counted_bars=IndicatorCounted();
   datetime nxtOptTime, rectBegin, rectEnd;
   int CurOptExp, MinFromHr, Minutes_Left;
   string OLName, OSPName;

//----


      if(prevSPLine!=""){
         //ObjectSet(prevSPLine,OBJPROP_PRICE1,WinMin);
         //ObjectSet(prevSPLine,OBJPROP_PRICE2,WinMax);
      }
      if(prevOptLine=="-"){
         if(Minute()>55 && Minute() <=60){
            // Print("Between 55 and 60 minutes");
            // Still within prev hour
            MinFromHr=Minute();
            Minutes_Left=10*60;
            Minutes_Left+=((60-MinFromHr)*60);
            CurOptExp=10;
            nxtOptTime=((TimeCurrent()-Seconds()) + Minutes_Left);
         }else if(Minute()>0 && Minute() < 10){
            // into next hour but less than 10 Minutes
            MinFromHr=Minute();
            Minutes_Left=(10-MinFromHr)*60;
            CurOptExp=10;
            nxtOptTime=((TimeCurrent()-Seconds()) + Minutes_Left);
         }else if(Minute()>10 && Minute()<25){
            MinFromHr=Minute();
            Minutes_Left=(25-MinFromHr)*60;
            
            CurOptExp=25;
            nxtOptTime=((TimeCurrent()-Seconds()) + Minutes_Left);
         }else if(Minute()>25 && Minute()<40){
            MinFromHr=Minute();
            Minutes_Left=(40-MinFromHr)*60;
            
            CurOptExp=40;
            nxtOptTime=((TimeCurrent()-Seconds()) + Minutes_Left);         
         }else if(Minute()>40 && Minute()<55){
            MinFromHr=Minute();
            Minutes_Left=(55-MinFromHr)*60;
            
            CurOptExp=55;
            nxtOptTime=((TimeCurrent()-Seconds()) + Minutes_Left);         
         }          
            rectEnd=nxtOptTime;
            rectBegin=( (nxtOptTime-(SweetSpotLength*60) ) );
            
            OLName="OptionExpires " + " M1 " + TimeToStr(nxtOptTime,TIME_DATE|TIME_MINUTES);
            OSPName="SweetSpot M1 " + TimeToStr(nxtOptTime,TIME_DATE|TIME_MINUTES);
            if(ObjectFind(OLName)<0)
            {   
               if(prevOptLine != ""){
                  ObjectSet(prevOptLine,OBJPROP_STYLE, 4);
                  ObjectSet(prevOptLine,OBJPROP_COLOR, Gray);
               }
               ObjectCreate( OLName,OBJ_VLINE,0,nxtOptTime,0);
               ObjectSet( OLName, OBJPROP_COLOR , LineColor);
               ObjectSet( OLName, OBJPROP_WIDTH , LineWidth);
               if(Back==true)ObjectSet( OLName, OBJPROP_BACK, Back);
               if(LineWidth<2)
               ObjectSet( OLName, OBJPROP_STYLE , LineStyle);
               prevOptLine=OLName;
               ObjectCreate(OSPName,16,0,rectBegin,WinMin,rectEnd,WinMax);
               ObjectSet(OSPName,OBJPROP_COLOR,SweetSpotColor);
               prevSPLine=OSPName;
            }         
      }
      
      if( Minute()==55 || Minute()==10 || Minute()==25 || Minute()==40){       
         if(Minute()==55){
            CurOptExp=55;
            nxtOptTime=((TimeCurrent()-Seconds())+(15*60));
         }else if(Minute()==10){
            CurOptExp=10;
            nxtOptTime=((TimeCurrent()-Seconds())+(15*60));
         }else if(Minute()==25){
            CurOptExp=25;
            nxtOptTime=((TimeCurrent()-Seconds())+(15*60));
         }else if(Minute()==40){
            CurOptExp=40;
            nxtOptTime=((TimeCurrent()-Seconds())+(15*60));
         }
         
         rectBegin=nxtOptTime;
         rectEnd=( (nxtOptTime-(SweetSpotLength*60) ) );
      
         OLName="OptionExpires " + " M1 " + TimeToStr(nxtOptTime,TIME_DATE|TIME_MINUTES);
         OSPName="SweetSpot M1 " + TimeToStr(nxtOptTime,TIME_DATE|TIME_MINUTES);
         
         if(ObjectFind(OLName)<0)
         {   
            if(prevOptLine != ""){
               ObjectSet(prevOptLine,OBJPROP_STYLE, 4);
               ObjectSet(prevOptLine,OBJPROP_COLOR, Gray);
               ObjectSet(prevSPLine,OBJPROP_COLOR,ExpSweetSpotCol);
            }
            ObjectCreate( OLName,OBJ_VLINE,0,nxtOptTime,0);
            ObjectSet( OLName, OBJPROP_COLOR , LineColor);
            ObjectSet( OLName, OBJPROP_WIDTH , LineWidth);
            if(Back==true)ObjectSet( OLName, OBJPROP_BACK, Back);
            if(LineWidth<2)
            ObjectSet( OLName, OBJPROP_STYLE , LineStyle);
            prevOptLine=OLName;
            ObjectCreate(OSPName,OBJ_RECTANGLE,0,rectBegin,WinMin,rectEnd, WinMax );
            ObjectSet(OSPName,OBJPROP_COLOR,SweetSpotColor);
            prevSPLine=OSPName;
         }
      }            
//----
   return(0);
  }
//+------------------------------------------------------------------+